From b1827a3a2fc0447e53d36ca3d6124298b6594aa3 Mon Sep 17 00:00:00 2001
From: Nick Steel <nick@nsteel.co.uk>
Date: Thu, 16 Jun 2022 02:59:15 +0100
Subject: [PATCH 06/21] Remove pyspotify: dictinct

---
 mopidy_spotify/distinct.py   | 55 +++++++++++++++---------------------
 mopidy_spotify/library.py    |  2 +-
 mopidy_spotify/lookup.py     |  8 ++----
 mopidy_spotify/translator.py |  3 ++
 mopidy_spotify/web.py        |  4 +--
 tests/conftest.py            | 10 +------
 tests/test_distinct.py       | 24 +++++++---------
 tests/test_lookup.py         | 12 ++++----
 tests/test_translator.py     |  7 +++++
 tests/test_web.py            | 11 ++++----
 10 files changed, 60 insertions(+), 76 deletions(-)

diff --git a/mopidy_spotify/distinct.py b/mopidy_spotify/distinct.py
index 684036df..61c254f0 100644
--- a/mopidy_spotify/distinct.py
+++ b/mopidy_spotify/distinct.py
@@ -1,50 +1,49 @@
 import logging
 
-import spotify
 from mopidy_spotify import search
 
 logger = logging.getLogger(__name__)
 
 
-def get_distinct(config, session, web_client, field, query=None):
+def get_distinct(config, playlists, web_client, field, query=None):
     # To make the returned data as interesting as possible, we limit
     # ourselves to data extracted from the user's playlists when no search
     # query is included.
 
     if field == "artist":
-        result = _get_distinct_artists(config, session, web_client, query)
+        result = _get_distinct_artists(config, playlists, web_client, query)
     elif field == "albumartist":
-        result = _get_distinct_albumartists(config, session, web_client, query)
+        result = _get_distinct_albumartists(config, playlists, web_client, query)
     elif field == "album":
-        result = _get_distinct_albums(config, session, web_client, query)
+        result = _get_distinct_albums(config, playlists, web_client, query)
     elif field == "date":
-        result = _get_distinct_dates(config, session, web_client, query)
+        result = _get_distinct_dates(config, playlists, web_client, query)
     else:
         result = set()
 
     return result - {None}
 
 
-def _get_distinct_artists(config, session, web_client, query):
+def _get_distinct_artists(config, playlists, web_client, query):
     logger.debug(f"Getting distinct artists: {query}")
     if query:
         search_result = _get_search(
-            config, session, web_client, query, artist=True
+            config, web_client, query, artist=True
         )
         return {artist.name for artist in search_result.artists}
     else:
         return {
             artist.name
-            for track in _get_playlist_tracks(config, session)
+            for track in _get_playlist_tracks(config, playlists, web_client)
             for artist in track.artists
         }
 
 
-def _get_distinct_albumartists(config, session, web_client, query):
+def _get_distinct_albumartists(config, playlists, web_client, query):
     logger.debug(f"Getting distinct albumartists: {query}")
     if query:
         search_result = _get_search(
-            config, session, web_client, query, album=True
+            config, web_client, query, album=True
         )
         return {
             artist.name
@@ -55,31 +54,31 @@ def _get_distinct_albumartists(config, session, web_client, query):
     else:
         return {
             track.album.artist.name
-            for track in _get_playlist_tracks(config, session)
+            for track in _get_playlist_tracks(config, playlists, web_client)
             if track.album and track.album.artist
         }
 
 
-def _get_distinct_albums(config, session, web_client, query):
+def _get_distinct_albums(config, playlists, web_client, query):
     logger.debug(f"Getting distinct albums: {query}")
     if query:
         search_result = _get_search(
-            config, session, web_client, query, album=True
+            config, web_client, query, album=True
         )
         return {album.name for album in search_result.albums}
     else:
         return {
             track.album.name
-            for track in _get_playlist_tracks(config, session)
+            for track in _get_playlist_tracks(config, playlists, web_client)
             if track.album
         }
 
 
-def _get_distinct_dates(config, session, web_client, query):
+def _get_distinct_dates(config, playlists, web_client, query):
     logger.debug(f"Getting distinct album years: {query}")
     if query:
         search_result = _get_search(
-            config, session, web_client, query, album=True
+            config, web_client, query, album=True
         )
         return {
             album.date
@@ -89,13 +88,13 @@ def _get_distinct_dates(config, session, web_client, query):
     else:
         return {
             f"{track.album.year}"
-            for track in _get_playlist_tracks(config, session)
+            for track in _get_playlist_tracks(config, playlists, web_client)
             if track.album and track.album.year not in (None, 0)
         }
 
 
 def _get_search(
-    config, session, web_client, query, album=False, artist=False, track=False
+    config, web_client, query, album=False, artist=False, track=False
 ):
 
     types = []
@@ -106,20 +105,12 @@ def _get_search(
     if track:
         types.append("track")
 
-    return search.search(config, session, web_client, query, types=types)
+    return search.search(config, web_client, query, types=types)
 
 
-def _get_playlist_tracks(config, session):
-    if not config["allow_playlists"]:
+def _get_playlist_tracks(config, playlists, web_client):
+    if not playlists or not config["allow_playlists"]:
         return
 
-    for playlist in session.playlist_container:
-        if not isinstance(playlist, spotify.Playlist):
-            continue
-        playlist.load(config["timeout"])
-        for track in playlist.tracks:
-            try:
-                track.load(config["timeout"])
-                yield track
-            except spotify.Error:  # TODO Why did we get "General error"?
-                continue
+    for playlist_ref in playlists.as_list():
+        yield from playlist.get_items(playlist_ref.uri)
diff --git a/mopidy_spotify/library.py b/mopidy_spotify/library.py
index 05ca19ac..f2024d4f 100644
--- a/mopidy_spotify/library.py
+++ b/mopidy_spotify/library.py
@@ -25,7 +25,7 @@ def browse(self, uri):
     def get_distinct(self, field, query=None):
         return distinct.get_distinct(
             self._config,
-            self._backend._session,
+            self._backend.playlists,
             self._backend._web_client,
             field,
             query,
diff --git a/mopidy_spotify/lookup.py b/mopidy_spotify/lookup.py
index a34f05b2..dc9e9598 100644
--- a/mopidy_spotify/lookup.py
+++ b/mopidy_spotify/lookup.py
@@ -54,17 +54,13 @@ def _lookup_album(config, web_client, link):
     if web_album == {}:
         raise WebError("Invalid album response")
 
-    tracks = translator.web_to_album_tracks(web_album, bitrate=config["bitrate"])
-    for track in tracks:
-        yield track
+    yield from translator.web_to_album_tracks(web_album, bitrate=config["bitrate"])
 
 
 def _lookup_artist(config, web_client, link):
     web_albums = web_client.get_artist_albums(link)
     for web_album in web_albums:
-        tracks = translator.web_to_album_tracks(web_album, bitrate=config["bitrate"])
-        for track in tracks:
-            yield track
+        yield from translator.web_to_album_tracks(web_album, bitrate=config["bitrate"])
 
 
 def _lookup_playlist(config, web_client, link):
diff --git a/mopidy_spotify/translator.py b/mopidy_spotify/translator.py
index c12062c7..d180fa8e 100644
--- a/mopidy_spotify/translator.py
+++ b/mopidy_spotify/translator.py
@@ -318,6 +318,9 @@ def web_to_album_tracks(web_album, bitrate=None):
     if album is None:
         return []
 
+    if not web_album.get("is_playable", False):
+        return []
+
     web_tracks = web_album.get("tracks", {}).get("items", [])
     if not isinstance(web_tracks, list):
         return []
diff --git a/mopidy_spotify/web.py b/mopidy_spotify/web.py
index 68b8f77c..ee01090a 100644
--- a/mopidy_spotify/web.py
+++ b/mopidy_spotify/web.py
@@ -509,9 +509,7 @@ def get_artist_albums(self, web_link):
                 except ValueError as exc:
                     logger.error(exc)
                     continue
-                full_album = self.get_album(web_link)
-                if full_album.get("is_playable", False):
-                    yield full_album
+                yield self.get_album(web_link)
 
     def get_track(self, web_link):
         if web_link.type != LinkType.TRACK:
diff --git a/tests/conftest.py b/tests/conftest.py
index 5ba4def4..d34ac1db 100644
--- a/tests/conftest.py
+++ b/tests/conftest.py
@@ -424,13 +424,6 @@ def mopidy_album_mock(mopidy_artist_mock):
     )
 
 
-@pytest.fixture
-def session_mock():
-    sp_session_mock = mock.Mock(spec=spotify.Session)
-    sp_session_mock.connection.state = spotify.ConnectionState.LOGGED_IN
-    return sp_session_mock
-
-
 @pytest.fixture
 def web_client_mock():
     web_client_mock = mock.MagicMock(spec=web.SpotifyOAuthClient)
@@ -440,10 +433,9 @@ def web_client_mock():
 
 
 @pytest.fixture
-def backend_mock(session_mock, config, web_client_mock):
+def backend_mock(config, web_client_mock):
     backend_mock = mock.Mock(spec=backend.SpotifyBackend)
     backend_mock._config = config
-    backend_mock._session = session_mock
     backend_mock._bitrate = 160
     backend_mock._web_client = web_client_mock
     return backend_mock
diff --git a/tests/test_distinct.py b/tests/test_distinct.py
index 88de6846..afc98b4a 100644
--- a/tests/test_distinct.py
+++ b/tests/test_distinct.py
@@ -7,19 +7,15 @@
 
 
 @pytest.fixture
-def session_mock_with_playlists(
-    session_mock,
-    sp_playlist_mock,
-    sp_unloaded_playlist_mock,
-    sp_playlist_folder_start_mock,
-    sp_playlist_folder_end_mock,
+def web_client_mock_with_playlists(
+    web_client_mock,
+    web_playlist_mock,
 ):
 
-    session_mock.playlist_container = [
-        sp_playlist_folder_start_mock,
-        sp_playlist_mock,
-        sp_unloaded_playlist_mock,
-        sp_playlist_folder_end_mock,
+    web_client_mock.get_user_playlists.return_value = [
+        web_playlist_mock,
+        {},
+        web_playlist_mock,
     ]
     return session_mock
 
@@ -52,7 +48,7 @@ def test_get_distinct_unsupported_field_types_returns_nothing(provider, field):
     ],
 )
 def test_get_distinct_without_query_when_playlists_enabled(
-    session_mock_with_playlists, provider, field, expected
+    web_client_mock_with_playlists, provider, field, expected
 ):
 
     assert provider.get_distinct(field) == expected
@@ -98,10 +94,10 @@ def test_get_distinct_without_query_returns_nothing_when_playlists_disabled(
     ],
 )
 def test_get_distinct_with_query(
-    search_mock, provider, config, session_mock, field, query, expected, types
+    search_mock, provider, config, web_client_mock, field, query, expected, types
 ):
 
     assert provider.get_distinct(field, query) == expected
     search_mock.search.assert_called_once_with(
-        mock.ANY, mock.ANY, mock.ANY, query, types=types
+        mock.ANY, mock.ANY, query, types=types
     )
diff --git a/tests/test_lookup.py b/tests/test_lookup.py
index 3d1e45a8..65222643 100644
--- a/tests/test_lookup.py
+++ b/tests/test_lookup.py
@@ -103,16 +103,16 @@ def test_lookup_of_artist_uri(web_track_mock, web_album_mock, web_client_mock, p
 
 
 def test_lookup_of_artist_ignores_unavailable_albums(
-    session_mock, sp_artist_browser_mock, sp_album_browser_mock, provider
+    web_client_mock, web_album_mock, web_album_mock2, provider
 ):
-    sp_artist_mock = sp_artist_browser_mock.artist
-    session_mock.get_link.return_value = sp_artist_mock.link
-    sp_album_mock = sp_album_browser_mock.album
-    sp_album_mock.is_available = False
+    web_album_mock["is_playable"] = False
+    web_client_mock.get_artist_albums.return_value = [
+        web_album_mock, web_album_mock2,
+    ]
 
     results = provider.lookup("spotify:artist:abba")
 
-    assert len(results) == 0
+    assert len(results) == 2
 
 
 def test_lookup_of_artist_uri_ignores_compilations(
diff --git a/tests/test_translator.py b/tests/test_translator.py
index a0120315..460158f1 100644
--- a/tests/test_translator.py
+++ b/tests/test_translator.py
@@ -816,6 +816,13 @@ def test_web_to_album_tracks_empty(self, web_album_mock):
 
         assert len(tracks) == 0
 
+    def test_web_to_album_tracks_unplayable(self, web_album_mock):
+        web_album_mock["is_playable"] = False
+
+        tracks = translator.web_to_album_tracks(web_album_mock)
+
+        assert len(tracks) == 0
+
 
 class TestWebToTrack:
     def test_calls_web_to_track_ref(self, web_track_mock):
diff --git a/tests/test_web.py b/tests/test_web.py
index 2f522d04..1a4a17fe 100644
--- a/tests/test_web.py
+++ b/tests/test_web.py
@@ -1182,8 +1182,7 @@ def test_get_artist_albums(self, artist_albums_mock, web_album_mock, web_album_m
         assert results[1]["name"] == "XYZ 789"
 
     @responses.activate
-    def test_get_artist_albums_ignores_unplayable(self, artist_albums_mock, web_album_mock, web_album_mock2, spotify_client):
-        web_album_mock["is_playable"] = False
+    def test_get_artist_albums_error(self, artist_albums_mock, web_album_mock, spotify_client, caplog):
         responses.add(
             responses.GET,
             url(f"artists/abba/albums"),
@@ -1197,15 +1196,17 @@ def test_get_artist_albums_ignores_unplayable(self, artist_albums_mock, web_albu
         responses.add(
             responses.GET,
             url(f"albums/xyz"),
-            json=web_album_mock2,
+            json={"error": "bar"},
         )
 
         link = web.WebLink.from_uri("spotify:artist:abba")
         results = list(spotify_client.get_artist_albums(link))
 
         assert len(responses.calls) == 3
-        assert len(results) == 1
-        assert results[0]["name"] == "XYZ 789"
+        assert len(results) == 2
+        assert results[0]["name"] == "DEF 456"
+        assert results[1] == {}
+        assert "Spotify Web API request failed: bar" in caplog.text
 
     @responses.activate
     @pytest.mark.parametrize(

